#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <GL/glut.h>

#include "pnm.h"
#include "matrix.h"

double rotate_y; 
double rotate_x;


MATRIX *IMG;
GLvoid *pixels;

double K[16] = {  815.3419,   0.0,    0.0,  0.0,
                    0.0,    815.3419, 0.0,  0.0,
                 -300.0,   -200.0,   51.0, -1.0,
                    0.0,      0.0,   20.0,  0.0 };	
int h=400,w=600;

/**
R =  [[ 0.90646238  0.42113058 -0.03122481]
 [-0.18266508  0.45769434  0.8701433 ]
 [ 0.38073537 -0.78304849  0.49180855]]

vectort[3] = { -0.305189648, 0.0176868943, -78.8966781 };
**/
double MatrixRt[16] = {
  0.90646238, -0.18266508,   0.38073537, 0.0,
  0.42113058,  0.45769434,  -0.78304849, 0.0,
 -0.03122481,  0.87014330,   0.49180855, 0.0,
 -0.30518965,  0.01768689, -78.8966781,  1.0 };

double pos[20];

void display()
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	// glGetDoublev( GL_CURRENT_RASTER_POSITION, pos );
	// fprintf( stderr,"pos: %lf %lf %lf\n", pos[0], pos[1], pos[2] );

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();

	glDisable(GL_DEPTH_TEST);
	// glRasterPos2i(0,0);
	// glPixelZoom(1.0,0.25);
	// glRasterPos2f(0.0, 0.2);
	glDrawPixels( IMG->cols, IMG->rows, GL_RGB, GL_UNSIGNED_BYTE, pixels );
	// glPixelZoom(1.0,1.0);
	glPopMatrix();

	glPushMatrix();
	glEnable(GL_DEPTH_TEST);
	glMultMatrixd( MatrixRt ); 

	/** Se dibuja el perímetro del marcador **/
	glBegin( GL_LINE_LOOP );

	glColor3f(  0.0,  1.0,  0.0 );
	glVertex3f( -10.0, -10.0, 0 );
	glVertex3f(  10.0, -10.0, 0 );
	glVertex3f(  10.0,  10.0, 0 );
	glVertex3f( -10.0,  10.0, 0 );

  	glEnd();

	/*Hace la rotación por medio del teclado
	  afecta a toda la geometría*/	

	//glRotatef( rotate_x, 1.0, 0.0, 0.0 );
	glRotatef( rotate_y, 0.0, 0.0, 1.0 );
 
	/*A PARTIR DE AQUI SE DIBUJA EL(LOS) OBJETO(S) QUE ES
	  AFECTADO POR TODAS LAS TRANSFORMACIONES*/
	glBegin( GL_TRIANGLES );

	glColor3f( 1.0, 0.0, 0.0 );
	glVertex3f( 0.0, 0.0, 0.0 );
	glVertex3f( 8.0, 0.0, 0.0 );
	glVertex3f( 4.0, 0.0, 8.0 );

  	glEnd();
	glPopMatrix();

	glutSwapBuffers();
}


void teclado1( unsigned char key, int x, int y )
{
	switch( key ) { 
		case 27:
			exit(0);
			break;
	}
}
 
/*Función para el llamado de las teclas*/
void teclado( int key, int x, int y )
{
	switch( key ) { 
		/*Flecha derecha: aumentar rotación 5 grados*/
		case GLUT_KEY_RIGHT :
			rotate_y += 25.0;
			break;
		/*Flecha izquierda: disminuir rotación 5 grados*/
		case GLUT_KEY_LEFT :
			rotate_y -= 25.0;
			break;

		case GLUT_KEY_UP :
			rotate_x += 5.0;
			break;

		case GLUT_KEY_DOWN :
			rotate_x -= 5.0;
			break;

	}

	/* Actualiza la visualización */
	glutPostRedisplay();
}

void rotaTimer( int value ) 
{
	rotate_y += 4.0;
	if( rotate_y > 360.0 ) rotate_y = 0.0;

	glutPostRedisplay();
	glutTimerFunc( 17, rotaTimer, 0 );
}


int main(int argc, char* argv[])
{
	IMG = read_pnm( "marco.ppm" );
	if ( IMG == NULL ) {
		fprintf( stderr, "No puedo leer la imagen\n" );
		exit(1);
	}
	h = IMG->rows; 
	w = IMG->cols; 

	pixels=(unsigned char *) IMG->ptr[0];

  
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize( w, h );
	glutCreateWindow("Marcador plano");


	glEnable(GL_DEPTH_TEST);
	glClearColor (0.5, 0.5, 0.5, 0.0);
	glShadeModel (GL_FLAT);

	glViewport (0, 0, (GLsizei)w, (GLsizei)h);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho ( 0.0, w, 0.0, h, 1.0, 51.0 );
	glMultMatrixd( K );

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity ();

	glutDisplayFunc(display);
	glutKeyboardFunc(teclado1);
	glutSpecialFunc(teclado);
	glutTimerFunc( 17, rotaTimer, 0 );
 	glutMainLoop();
 
 	return 0;
}
